/* 
 * Nama File : DoraMPEGCanvas.java 
 * Developed by : Lilik Haryanto 
 */ 

package org.secangkirkopipanas;
 
import javax.microedition.midlet.*; 
import javax.microedition.lcdui.*; 
import javax.microedition.media.*; 
import javax.microedition.media.control.*; 
import java.io.*;
 
public class DoraMPEGCanvas extends Canvas implements CommandListener,  
PlayerListener, Runnable { 
     
    private DoraMPEGPlayer parent; 
    private Display display; 
     
    private Player player; 
    private VideoControl videoControl; 
     
    private String url; 
    private Thread initializer; 
     
    private Command btnClose; 
    private Command btnReplay; 
     
    public DoraMPEGCanvas(DoraMPEGPlayer parent) { 
        super(); 
        this.parent = parent; 
        display = Display.getDisplay(parent); 
        btnClose = new Command("Close", Command.SCREEN, 1); 
        addCommand(btnClose); 
        setCommandListener(this); 
    } 
     
    public void initializeVideo(String url){  
        this.url = url; 
        initializer = new Thread(this); 
        initializer.start(); 
    }  
     
    public void run() { 
        try {        
            player = Manager.createPlayer(url); 
            parent.updateGauge();       
            player.addPlayerListener(this);     
            player.realize(); 
            parent.updateGauge();         
            player.prefetch(); 
            parent.updateGauge(); 
        } catch (IOException ioe) { 
            Alert alert = new Alert("IOException thrown", ioe.getMessage(), 
                null, AlertType.ERROR); 
            display.setCurrent(alert);  
        } catch (MediaException me) { 
            Alert alert = new Alert("MediaException thrown", me.getMessage(), 
                null, AlertType.ERROR); 
            display.setCurrent(alert); 
        } 
  playVideo(); 
    } 
     
    public void playVideo() { 
        try { 
            /* ambil video control dan set menjadi display sedang aktif */ 
            videoControl = (VideoControl)player.getControl("VideoControl"); 
            if (videoControl != null) {     
                videoControl.initDisplayMode(videoControl.USE_DIRECT_VIDEO,  
                    this);                           
            } 
 
            parent.updateGauge(); 
            int cHeight = this.getHeight(); 
            int cWidth = this.getWidth(); 
            videoControl.setDisplaySize(cWidth, cHeight); 
            display.setCurrent(this); 
            videoControl.setVisible(true); 
            player.start(); 
        } catch (MediaException me) { 
            Alert alert = new Alert("MediaException thrown", me.getMessage(), 
                null, AlertType.ERROR); 
            display.setCurrent(alert); 
        } 
    } 
     
    public void paint(Graphics g) { 
        g.setColor(0, 0, 0); 
        g.fillRect(0, 0, getWidth(), getHeight()); 
    } 
     
    public void playerUpdate(Player p, String event, Object eventData) { 
        /* tambahkan pilihan "Replay" ketika video telah selesai */ 
        if (event == PlayerListener.END_OF_MEDIA) { 
            if (btnReplay == null) { 
                btnReplay = new Command("Replay", Command.SCREEN, 1); 
                addCommand(btnReplay); 
            }    
        } 
    } 
     
    public void commandAction(Command c, Displayable d) { 
        if (c == btnReplay) { 
            try{ 
                player.start(); 
            } catch (MediaException me) { 
                Alert alert = new Alert("MediaException thrown", 
                    me.getMessage(), null, AlertType.ERROR); 
                display.setCurrent(alert); 
            } 
        } else if (c == btnClose) { 
            player.close(); 
            parent.form.delete(1); 
            display.setCurrent(parent.form); 
            url = null; 
            parent = null; 
        } 
    } 
     
} 